﻿// PlainButton - ported from jbumUI.as to AS3 - Jim Bumgardner 2008
package 
{
	import flash.events.Event;
	import flash.display.Sprite;
	import flash.display.DisplayObject;
	import flash.display.GradientType;
	import flash.events.MouseEvent;
	import flash.geom.Rectangle;
    import Button_mc;
	
	public class PlainButton extends Sprite
	{
		var itsMC:Button_mc;
		var pressFunc;
		var isSpring:Boolean;
		// spring stuff
		var speed, tScale, stiffness, damping;
		
		public function PlainButton(mc, lab, pressFunc, isSpring=false)
		{
			this.itsMC = mc;
			mc.label_txt.text = lab;
			mc.buttonMode = true;
			this.pressFunc = pressFunc;
			itsMC.label_txt.textColor = 0x000000;
			mc.addEventListener(MouseEvent.MOUSE_UP, function(evt) { pressFunc(); } );
			if (isSpring) {
				// trace('making spring');
				this.speed = 0;   // current tween velocity
				this.tScale = itsMC.scaleX; // target scale
				this.stiffness = .4;
				this.damping = .8;
				mc.addEventListener(MouseEvent.MOUSE_OVER, function(evt) {   
																		  	tScale = 1.05;
																			itsMC.addEventListener(Event.ENTER_FRAME, springIt);
																			}   );
				mc.addEventListener(MouseEvent.MOUSE_OUT, function(evt) {  
																		 	tScale = .1; 
																			itsMC.addEventListener(Event.ENTER_FRAME, springIt);
																			 }   );
			}
			else {
				mc.addEventListener(MouseEvent.MOUSE_OVER, function(evt) {  itsMC.label_txt.textColor = 0xFFFFFF; }   );
				mc.addEventListener(MouseEvent.MOUSE_OUT, function(evt) {   itsMC.label_txt.textColor = 0x000000; }   );
			}
			itsMC.addChild(this);
		}

		function springIt(evt)
		{
			var ds = tScale - itsMC.scaleX;
			speed += ds*stiffness;
			speed *= damping;
			itsMC.scaleX += speed;
			itsMC.scaleY += speed;
			if (Math.abs(speed) < .0001) 
			{
				// trace('done spring');
				itsMC.scaleX = itsMC.scaleY = tScale;
				itsMC.removeEventListener(Event.ENTER_FRAME, springIt);
			}
		}
		
	} // end class
} // end package